#include <bits/stdc++.h>
using namespace std;
void generisi_delioce(int x, vector<int>& del){
    for(int i=1; i<=sqrt(x); i++){
        if(x%i==0){
            del.push_back(i);
            if(i!=x/i) del.push_back(x/i);
        }
    }
}
int xor_d(int x){
    int nijevisevasa=0;
    vector<int> del;
    generisi_delioce(x,del);
    int n=del.size();
    for(int i=0; i<n; i++){
        nijevisevasa^=del[i];
    }
    return nijevisevasa;
}
int main(){
    int n,k;
    cin>>n>>k;
    vector<int> d(k);
    for(int i=0; i<k; i++) cin>>d[i];
    for(int i=0; i<k; i++){
       cout<<xor_d(d[i])<<" ";
    }
}